/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include "project.h"
#include "dma_driver.h"
#include "ram_handler.h"
#include "stdio.h"

/* DMA Configuration constants for DMA_1 */
#define DMA_1_BYTES_PER_BURST (2u)
#define DMA_1_REQUEST_PER_BURST (1u)
#define DMA_1_SRC_BASE (CYDEV_PERIPH_BASE)
#define DMA_1_DST_BASE (CYDEV_SRAM_BASE)

uint8 dma_chan;
uint8 dma_done_flag = 0;
void DMA_config() {
     /* Variable declarations for DMA_1 */
    uint8 DMA_1_TD[1] = {0};
    
    /* DMA Configuration for DMA_1 */
    dma_chan = DMA_1_DmaInitialize(DMA_1_BYTES_PER_BURST, DMA_1_REQUEST_PER_BURST, 
        HI16(DMA_1_SRC_BASE), HI16(DMA_1_DST_BASE));
    DMA_1_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_1_TD[0], BUFFER_SIZE*DMA_1_BYTES_PER_BURST, CY_DMA_DISABLE_TD, DMA_1__TD_TERMOUT_EN | CY_DMA_TD_INC_DST_ADR);
    CyDmaTdSetAddress(DMA_1_TD[0], LO16((uint32)ADC_SAR_WRK0_PTR), LO16((uint32)CYDEV_SRAM_BASE));
    CyDmaChSetInitialTd(dma_chan, DMA_1_TD[0]);
    CyDmaChEnable(dma_chan, 1);
}

void set_dma_done_flag() {
    dma_done_flag = 1;
}

void dma_reset() {
    CyDmaChEnable(dma_chan, 1);
}

void poll_dma_done_flag() {
    while (dma_done_flag <= 0);
    dma_done_flag = 0;
    return;
}

/* [] END OF FILE */
