/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include "stdio.h"
#include "dma_driver.h"
#include "ram_handler.h"


#define ADC_BITS_12  12

static void hal_init() {
    ADC_Start();
    WaveDAC_Start();
    DMA_config();
    isr_DMA_Done_Start();
    UART_Start();
    UART_PutString("System Init\n");
}



int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */
    hal_init();
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    int32 adc_uv;
    char outputBuffer[40];
    int16 i;
    ADC_StartConvert();
    for(;;)
    {
        poll_dma_done_flag();
        CyDelay(50);
        display_sram_values();
        dma_reset();
    }
}

/* [] END OF FILE */
